#include <SoftwareSerial.h>
#include <coap_server.h>
#include <Wire.h>
#include "ESP8266.h"

ESP8266 wifi = ESP8266(Serial1);

int controlPin = 8;
int sensorPin = A0;
//SoftwareSerial mySerial(18, 19); // RX, TX

#define SSID "TODO"
#define PASS "TODO"

void setup()
{
  pinMode(11, OUTPUT);
  digitalWrite(11, HIGH);
  pinMode(controlPin, OUTPUT);  //sensor on/off control
  digitalWrite(controlPin, HIGH);

  pinMode(12, OUTPUT);
  digitalWrite(12, HIGH);

  Serial.begin(57600);
  Serial1.begin(9600);

  wifi.begin();
  wifi.setTimeout(1000);

}

uint8_t state = 0;
uint16_t g_seq = 0;

uint8_t sleepTime = 5;

IPAddress ip;

void loop()
{


  if (Serial1.available()) {
    Serial.write(Serial1.read());
  }

  unsigned char c;
  if (Serial.available()) {
    c = Serial.read();
    switch(c)
    {
      case 'r':
        /* Better to restart before doing anything else */
        Serial1.println("AT+RST");
        break;
      case 'c':
        /* Check if working */
        Serial1.println("AT");
        break;
      case 's':
        /* Set WiFi mode as both STA and AP */
        Serial1.println("AT+CWMODE=3");
        break;
      case 'd':
        /* List visible access points */
        Serial1.println("AT+CWJAP?");
        break;
      case 'w':
        /* Join Access Point  */
        Serial1.println("AT+CWJAP=\"TODO\",\"TODO\"");
        break;      
      case 'i':
        /* Get allocated IP address */
        Serial1.println("AT+CIFSR");
        break;
      case 'l':
        /* Multiple TCP/UDP Connections */
        Serial1.println("AT+CIPMUX=1");
        break;
      case 'p':
        /* Set esp as server on port 8081 */
        Serial1.println("AT+CIPSERVER=1,8081");
        break;
      case 'x':
        Serial1.println("AT+CIPSEND=0,4");
        break;      
    }
 }
}

String getStatus(ESP8266CommandStatus status)
{
    switch (status) {
    case ESP8266_COMMAND_INVALID:
        return "INVALID";
        break;

    case ESP8266_COMMAND_TIMEOUT:
        return "TIMEOUT";
        break;

    case ESP8266_COMMAND_OK:
        return "OK";
        break;

    case ESP8266_COMMAND_NO_CHANGE:
        return "NO CHANGE";
        break;

    case ESP8266_COMMAND_ERROR:
        return "ERROR";
        break;

    case ESP8266_COMMAND_NO_LINK:
        return "NO LINK";
        break;

    case ESP8266_COMMAND_TOO_LONG:
        return "TOO LONG";
        break;

    case ESP8266_COMMAND_FAIL:
        return "FAIL";
        break;

    default:
        return "UNKNOWN COMMAND STATUS";
        break;
    }
}
